%% Ej 2 TP 3  -  SyS 2017

%// Autor: SR
%// 1- Ejemplo donde no se cumple linealidad
%// 2- Ejemplo donde se cumple invarianza al desplazamiento.

clear all; close all; clc;

%% 2)e) . Ejemplo donde no se cumple Linealidad.

n = -50:50;
c = 2;
A = 1.5;
x1 = A*sin(2*pi.*n/15);
y1 = x1.*((x1<=c) & (x1>=-c)) + c.*(x1>c) - c.*(x1<-c);
x2 = ones(1,length(n));
y2 = x2.*((x2<=c) & (x2>=-c)) + c.*(x2>c) - c.*(x2<-c);

x = x1 + x2;
y = x.*((x<=c) & (x>=-c)) + c.*(x>c) - c.*(x<-c);

figure('units','normalized','outerposition',[0 0 1 1]) % Creo y maximizo figura.

subplot(3,2,1)
stem(n,x1,'filled');
title('Entrada $x_1[n]$','Interpreter','Latex');
set(gca,'Fontsize',15);ylim([-3 3]);grid on;

subplot(3,2,2)
stem(n,y1,'filled');
title('Salida $y_1[n]$','Interpreter','Latex');
set(gca,'Fontsize',15);ylim([-3 3]);grid on;

subplot(3,2,3)
stem(n,x2,'r','filled');title('Entrada $x_2[n]$','Interpreter','Latex');
set(gca,'Fontsize',15);ylim([-3 3]);grid on;

subplot(3,2,4)
stem(n,y2,'r','filled');title('Salida $y_2[n]$','Interpreter','Latex');
set(gca,'Fontsize',15);ylim([-3 3]);grid on;

subplot(3,2,5)
stem(n,x1+x2,'k','filled');title('Entrada $x_1[n] + x_2[n]$','Interpreter','Latex');
set(gca,'Fontsize',15);ylim([-3 3]);grid on;

subplot(3,2,6)
stem(n,y1+y2,'g','filled');hold on;
stem(n,y,'k');title('y[n] vs $y_1[n] + y_2[n]$','Interpreter','Latex');
set(gca,'Fontsize',15);ylim([-3 3]);grid on;
legend('y[n]','y_1[n] + y_2[n]','Location','SouthWest');



%% 2)f) y[n] = x[-n] . Ejemplo donde no se cumple ID.

n = -10:10;
x = 1.*(n>=0 & n<=3);
x_corrido = 1.*(n>=1 & n<=4);
y = flip(x);
y_corrido = [0 y(1:end-1)];
y2 = flip(x_corrido);

figure('units','normalized','outerposition',[0 0 1 1]) % Creo y maximizo figura.

subplot(5,1,1)
stem(n,x,'filled');grid on;
title('$x[n]$','Interpreter','Latex');ylim([-0.1 1.1]);set(gca,'Fontsize',15);

subplot(5,1,2)
stem(n,y,'r','filled');grid on;
title('$y[n] = x[-n]$','Interpreter','Latex');ylim([-0.1 1.1]);set(gca,'Fontsize',15);

subplot(5,1,3)
stem(n,x_corrido,'k','filled');grid on;
title('$x_2 = x[n-1]$','Interpreter','Latex');ylim([-0.1 1.1]);set(gca,'Fontsize',15);

subplot(5,1,4)
stem(n,y_corrido,'m','filled');grid on;
title('$y[n-1]$','Interpreter','Latex');ylim([-0.1 1.1]);set(gca,'Fontsize',15);

subplot(5,1,5)
stem(n,y2,'g','filled');grid on;
title('$y_2[n] = x_2[-n]$','Interpreter','Latex');ylim([-0.1 1.1]);set(gca,'Fontsize',15);
