%% Ej 1 TP 3  -  SyS 2017

%// Autor: SR
%// 1- Ejemplo donde no se cumple invarianza al desplazamiento.
%// 2- Ejemplo donde se cumple invarianza al desplazamiento.

% Necesita (aunque puede implementarse de otro modo) las funciones 
% 'Secuencia_x_1' y 'Secuencia_x_1_corrida'.

clear all; close all; clc;

%% Sistema y[n] = x[n^2]

n = -6:6;
x = Secuencia_x_1(n);
y = Secuencia_x_1(n.^2);
x_corrido = Secuencia_x_1_corrida(n);
y_corrido = Secuencia_x_1((n-2).^2);
y2 = Secuencia_x_1_corrida(n.^2);

figure('units','normalized','outerposition',[0 0 1 1]) % Creo y maximizo figura.
subplot(3,2,1);
stem(n,x,'filled');grid on;title('$x[n] = u[n] - u[n-4]$','Interpreter','Latex');ylim([-0.1 1.1]);
set(gca,'FontSize',15)
subplot(3,2,2);
stem(n,y,'filled');grid on;title('$y[n] = x[n^2] = u[n^2] - u[n^2-4]$','Interpreter','Latex');ylim([-0.1 1.1]);
set(gca,'FontSize',15)
subplot(3,2,3);
stem(n,x_corrido,'filled');grid on;title('$x_2[n] = x[n-2]$','Interpreter','Latex');ylim([-0.1 1.1]);
set(gca,'FontSize',15)
subplot(3,2,4);
stem(n,y_corrido,'filled');grid on;title('$y[n-2] = u[(n-2)^2] - u[(n-2)^2-4]$','Interpreter','Latex');ylim([-0.1 1.1]);
set(gca,'FontSize',15)
subplot(3,1,3);
stem(n,y2,'filled');grid on;title('$y_2[n] = u[n^2-2] - u[n^2-6]$','Interpreter','Latex');ylim([-0.1 1.1]);
set(gca,'FontSize',15)

%% Sistema y[n] = x[n] - x[n-1]

n = -1:7;
x = Secuencia_x_1(n);
y = Secuencia_x_1(n) - Secuencia_x_1(n-1);
x_corrido = Secuencia_x_1_corrida(n);
y_corrido = Secuencia_x_1(n-2) - Secuencia_x_1(n-1-2);
y2 = Secuencia_x_1_corrida(n) - Secuencia_x_1_corrida(n-1);

figure('units','normalized','outerposition',[0 0 1 1]) % Creo y maximizo figura.
subplot(3,2,1);
stem(n,x,'filled');grid on;title('$x[n] = u[n] - u[n-4]$','Interpreter','Latex');ylim([-1.1 1.1]);
set(gca,'FontSize',15)
subplot(3,2,2);
stem(n,y,'filled');grid on;title('$y[n] = x[n] - x[n-1] = (u[n] - u[n-4]) - (u[n-1] - u[n-5])$','Interpreter','Latex');ylim([-1.1 1.1]);
set(gca,'FontSize',15)
subplot(3,2,3);
stem(n,x_corrido,'filled');grid on;title('$x_2[n] = x[n-2]$','Interpreter','Latex');ylim([-1.1 1.1]);
set(gca,'FontSize',15)
subplot(3,2,4);
stem(n,y_corrido,'filled');grid on;title('$y[n-2] = (u[n-2] - u[n-6]) - (u[n-3) - u[n-7])$','Interpreter','Latex');ylim([-1.1 1.1]);
set(gca,'FontSize',15)
subplot(3,1,3);
stem(n,y2,'filled');grid on;title('$y_2[n] = y[n-2]$','Interpreter','Latex');ylim([-1.1 1.1]);
set(gca,'FontSize',15)